<?php
declare(strict_types=1);

namespace FiloBlu\Flow\Model\Channel\In;

use FiloBlu\Flow\Helper\LoggerProvider;
use FiloBlu\Flow\Model\Channel\ConfigFactory;
use Magento\Framework\App\ResourceConnection;
use Magento\Framework\DB\Adapter\AdapterInterface;
use Magento\Framework\ObjectManagerInterface;

/**
 * Class Bundle
 * @package FiloBlu\FlowOBag\Model\Channel\In
 */
class Bundle extends AbstractModel
{
    /**
     * @var ResourceConnection
     */
    private $resourceConnection;

    /**
     * @var AdapterInterface
     */
    private $connection;

    /**
     * @param LoggerProvider $loggerProvider
     * @param ConfigFactory $channelConfigFactory
     * @param ObjectManagerInterface $objectManager
     * @param ResourceConnection $resourceConnection
     */
    public function __construct(
        LoggerProvider $loggerProvider, 
        ConfigFactory $channelConfigFactory, 
        ObjectManagerInterface $objectManager,
        ResourceConnection $resourceConnection
    )
    {
        parent::__construct($loggerProvider, $channelConfigFactory, $objectManager);
        $this->resourceConnection = $resourceConnection;
    }


    /**
     * @return bool
     */
    public function commitData()
    {

        $metaFileId = $this->getFile()->getId();
        /*
         *  
         * UPDATE  obag_mage.flow_from_bundle SET bundle_option_default = 0 WHERE  meta_file  = 1901;
         * UPDATE
         *   obag_mage.flow_from_bundle AS t1, 
         *   (	
         *       SELECT
         *           MIN(x.meta_id) as meta_id
         *           FROM
         *           obag_mage.flow_from_bundle x
         *       WHERE
         *           x.meta_file = 1901
         *       GROUP BY
         *           x.bundle_sku, x.bundle_option_name 
         *   )  AS t2
         *   SET t1.bundle_option_default = 1
         *   WHERE  t1.meta_id =  t2.meta_id		
         */
        $tableName = $this->getConnection()->getTableName('flow_from_bundle');
        $sql1 = "UPDATE  $tableName SET bundle_option_default = 0 WHERE  meta_file  = $metaFileId;";
        $this->getConnection()->query($sql1);
        $sql2 = "UPDATE
                $tableName AS t1, 
                (	
                    SELECT
                        MIN(x.meta_id) as meta_id
                        FROM
                        $tableName x
                    WHERE
                        x.meta_file = $metaFileId
                    GROUP BY
                        x.bundle_sku, x.bundle_option_name 
                )  AS t2
                SET t1.bundle_option_default = 1
                WHERE  t1.meta_id =  t2.meta_id";
        $this->getConnection()->query($sql2);
        return parent::commitData();
    }

    /**
     * @return AdapterInterface
     */
    protected function getConnection()
    {
        if ($this->connection === null) {
            $this->connection = $this->resourceConnection->getConnection();
        }

        return $this->connection;
    }
    
    
}
